/* main.h - insert file for main.c */

/* global variables defined for main */
#ifdef MAIN_VARS
    FILE *fpo ;
    unsigned randomSeed  ;
    unsigned randomSeed2 ;
    char cktName[128] ;
    int connection_machine ;
    int estimate_feeds ;
    int tw_fast ;
    int gate_array_special ;
    int pin_layers_given ;
    int no_feeds_side_nets ;
    int no_net_normalize ;
    int route2act = -1;    /* added for placement adjusted for routing */
    int routeGrid = -1;    /* used only if global routing is performed */
    int gridCell = -1;    /* used only if global routing is performed */
    int feedLayer ;
    int resume_run ;
    int attmax ;
    int maxCellO ;
    int iteration ;
    int iwire ;
    int iwirex ;
    int iwirey ;
    int fwire ;
    int fwirex ;
    int fwirey ;
    int blkxspan ;
    int blkyspan ;
    int ffeeds ;
    int addFeeds ;
    int fdWidth ;
    int lrtxspan ;
    int lrtyspan ;
    int **pairArray ;
    int attprcel ;
    int doglobal ; 
    int cswaps ;
    int costonly ;
    int restart  ;
    int ifrange ;
    int *fixarray ;
    double T ;
    double Tzero ;
    double *desired_accept ;
    double imprange ;
    double binpenCon ;
    double indent ;
    double rowSep ;
    double roLenCon ;
    double stopdeg ;
    double macspace[16] ;
    double cost_scale_factor ;

#else

    extern double *desired_accept ;
    extern double imprange ;
    extern int estimate_feeds ;
    extern int connection_machine ;
    extern int tw_fast ;
    extern int gate_array_special ;
    extern int uneven_cell_height ;
    extern int pin_layers_given ;
    extern int no_feeds_side_nets ;
    extern int no_net_normalize ;
    extern int route2act;    /* added for placement adjusted for routing */
    extern int track_spacing;    /* used only if global routing is performed */
    extern int gridCell;    /* used only if global routing is performed */
    extern int routeGrid;    /* used only if global routing is performed */
    extern int feedLayer ;
    extern unsigned randomSeed  ;
    extern unsigned randomSeed2 ;
    extern char cktName[128] ;
    extern int resume_run ;
    extern int attmax ;
    extern int maxCellO ;
    extern int iteration ;
    extern int iwire ;
    extern int iwirex ;
    extern int iwirey ;
    extern int fwire ;
    extern int fwirex ;
    extern int fwirey ;
    extern FILE *fpo ;
    extern int blkxspan ;
    extern int blkyspan ;
    extern int ffeeds ;
    extern int addFeeds ;
    extern int fdWidth ;
    extern int lrtxspan ;
    extern int lrtyspan ;
    extern int **pairArray ;
    extern int attprcel ;
    extern int doglobal ; 
    extern int cswaps ;
    extern int costonly ;
    extern int restart  ;
    extern int ifrange ;
    extern int *fixarray ;
    extern double binpenCon ;
    extern double T ;
    extern double Tzero ;
    extern double roLenCon ;
    extern double stopdeg ;
    extern double macspace[16] ;
    extern double indent ;
    extern double rowSep ;
    extern double cost_scale_factor ;
#endif

extern int tracks ;
extern int numChans ;
extern int *maxTrack ;
extern int rowHeight ;
extern int maxterm ;
extern int fdthrus ;
extern int numSegs ;
extern int impcount ;
extern int *nofeed ;
extern int stage ;
extern int *pinlist ;
extern int one_pin_feedthru ;
