#include "electra.h"
/*
 */
powerTerms()
{
    octObject *oNet;
    octObject *oTerm;
    octObject *newTerm();
    octObject *newNet();
    octBox area;
    int col;
    s_net net;


    oNet = newNet( "GND" );
    net.netId = oNet->objectId;
    net.termName = net.name = oNet->contents.net.name;

    area.lowerLeft.x = area.upperRight.x = 1;
    area.lowerLeft.y = area.upperRight.y = 1;

    oTerm = newTerm( M1M2TERM );
    newFterm( &net, oTerm );

    mkAttach( FullArray, &area, oTerm );
    if( !NoTermConstraints )constrainTerm( B_EDGE, oTerm );

    oNet = newNet( "Vdd" );
    net.netId = oNet->objectId;
    net.termName = net.name = oNet->contents.net.name;

    area.lowerLeft.x = area.upperRight.x = TotalCols - 2;
    area.lowerLeft.y = area.upperRight.y = TotalRows - 2;

    oTerm = newTerm( M1M2TERM );
    newFterm( &net, oTerm );

    mkAttach( FullArray, &area, oTerm );
    if( !NoTermConstraints )constrainTerm( T_EDGE, oTerm );
    area.lowerLeft.y = area.upperRight.y = 1;
    for( col = 11; col < TotalCols; col += 10 ){
	area.lowerLeft.x = area.upperRight.x = col;
	mkAttach(FullArray, &area, newTerm( M1M2TERM ));
    }
    area.lowerLeft.y = area.upperRight.y = TotalRows - 2;
    for( col = 6; col < TotalCols - 2; col += 10 ){
	area.lowerLeft.x = area.upperRight.x = col;
	mkAttach(FullArray, &area, newTerm( M1M2TERM ));
    }
}
