#include "electra.h"
/*
 * sizeTrans
 *
 * a stupid transistor size to see what sized trans do to the layout style
 */
char norLetter[5] = {'a','b','c','d','e' };
char nandLetter[5] = {'A','B','C','D','E' };

sizeTrans()
{
    s_network *network;
    int row, col;
    int tranNum;

    for( col = 0; col < NumCols; col++ ){
	for( network = NetworkArray[col]; network != NIL( s_network );
	     network = network->next ){
	    tranNum = 0;
	    if( col%2 == 0 ){
		for( row = network->top; row >= network->bottom; row-- ){
		    if( !IS_TRAN( row, col ))continue;
		    if( network->type == NAND )
			Matrix[row][col].letter = nandLetter[tranNum];
		    else 
			Matrix[row][col].letter = norLetter[tranNum];
		    tranNum++;
		}
	    } else {
		for( row = network->bottom; row <= network->top; row++ ){
		    if( !IS_TRAN( row, col ))continue;
		    if( network->type == NAND )
			Matrix[row][col].letter = nandLetter[tranNum];
		    else 
			Matrix[row][col].letter = norLetter[tranNum];
		    tranNum++;
		}
	    }
	}
    }
}

