#include "port.h"
#include "utility.h"

/*
 * parse_facet_spec: parses arg for cell and view.
 *    eg. parse_facet_spec("example:symbolic", name, value);
 *            set: name = "example"
 *                 value = "symbolic"
 *
 */
parse_facet_spec(arg, cell, view)
char *arg, **cell, **view;
{
    char *colon;

    if ((colon = strchr(arg, ':')) == NULL) {
	*cell = arg;
    } else {
	*colon = '\0';
	*cell = arg;
	*view = colon+1;
    }
}
