#include "copyright.h"
#include "port.h"

#include "header.h"
#include "tap.h"

extern char *get_tech_name();

char 	*layer_nameTable[3];
int 	layer_width[3];
int 	layer_spacing[3];
int  INPUT_SCALE;
int  OUTPUT_SCALE;

int  CONT_HEIGHT;
int  CONT_WIDTH;
int  MIN_SPACING;
octObject layers[3];
extern int tapGetStrangeConnector();

getDRC()
{
    struct octBox box;

    tapSetUserConnectorGenerator(tapGetStrangeConnector);
    (void) get_tech_name();

    set_up_layers(layers);

    /*  1 lamda = 20 oct units */
    INPUT_SCALE  = 1;
    OUTPUT_SCALE = 20;

    set_up_width_and_spacing(layers);

    get_connector_BB(&box,LAYER1,LAYER1,TAP_VERTICAL,TAP_VERTICAL);
    CONT_HEIGHT = box.upperRight.x - box.lowerLeft.x;
    CONT_WIDTH  = box.upperRight.y - box.lowerLeft.y;

    get_connector_BB(&box,LAYER1,LAYER2,TAP_VERTICAL,TAP_HORIZONTAL);
    CONT_HEIGHT = MAX(CONT_HEIGHT,box.upperRight.x - box.lowerLeft.x);
    CONT_WIDTH  = MAX(CONT_WIDTH,box.upperRight.y - box.lowerLeft.y);

    get_connector_BB(&box,LAYER2,LAYER2,TAP_HORIZONTAL,TAP_HORIZONTAL);
    CONT_HEIGHT = MAX(CONT_HEIGHT,box.upperRight.x - box.lowerLeft.x);
    CONT_WIDTH  = MAX(CONT_WIDTH,box.upperRight.y - box.lowerLeft.y);

    MIN_SPACING = MIN(layer_spacing[LAYER1], layer_spacing[LAYER2]);
}



