#include "copyright.h"
#include "port.h"

#include "header.h"

/*************************************************************************/

pnet new_net()
{
register pnet n;

n = CALLOC(1,struct net);

n->next = NULL;
n->cells = NULL;
n->id = NUM_OF_NETS++;
n->OCTid = -1;
n->lock = FALSE;
n->name = NULL;
n->free[PART_A] = n->locked[PART_A] = n->free[PART_B] = n->locked[PART_B] = 0;
n->two_conn = FALSE;
return(n);
}

/*************************************************************************/
pnetlist USED_NETLISTS = NULL;

pnetlist new_netlist()
{
register pnetlist nl;

if(USED_NETLISTS == NULL)
  nl = CALLOC(1,struct netlist);
else
  {
    nl = USED_NETLISTS;
    USED_NETLISTS = USED_NETLISTS->next;
  }

nl->net = NULL;
nl->next = NULL;
return(nl);
}

/*************************************************************************/

kill_netlist(nl)
pnetlist nl;
{
nl->next = USED_NETLISTS;
USED_NETLISTS = nl;
}

/*************************************************************************/

pcellist USED_CELLISTS = NULL;

pcellist new_cellist()
{
register pcellist cl;

if(USED_CELLISTS == NULL)
  cl = CALLOC(1,struct cellist);
else
  {
    cl = USED_CELLISTS;
    USED_CELLISTS = USED_CELLISTS->next;
  }

cl->cell = NULL;
cl->next = NULL;
return(cl);
}

/*************************************************************************/

kill_cellist(cl)
pcellist cl;
{
cl->next = USED_CELLISTS;
USED_CELLISTS = cl;
}

/*************************************************************************/

pcell new_cell()
{
register pcell c;

c = CALLOC(1,struct cell);

c->next = NULL;
c->prev = NULL;
c->bucket_next = NULL;
c->bucket_prev = NULL;
c->nets = NULL;
c->id = NUM_OF_CELLS++;
c->order = 0;
c->bucket = NULL;
c->gain = 0;
c->x = c->y = INF;
c->area = c->width = 1;
c->hard_link = NULL;
c->fixed = FALSE;
c->hl1 = c->hl2 = NULL;
c->HLparent = FALSE;
c->name = NULL;
c->paths= NULL;
return(c);
}

/*************************************************************************/

char *CALLOC_CHK(num)
register unsigned num;
{
register char *c;

if((c = (char*)malloc(num)) == NULL)
  {
    printf("(MIZER):ERROR in allocating %u bytes\n",num);
    quit();
  }
return(c);
}

