#include "mkInternal.h"
/*
 * mkGetGridCoords
 *
 * return the coordinates of the virtual grid lines
 */
void
mkGetGridCoords( arrayId, rowCoords, colCoords )
mkId arrayId;
int *rowCoords;
int *colCoords;
{
    s_array *array;
    int index;
    s_cpmNode **grid;

    MK_START( "mkGetCridCoords" );

    array = mk_get_array( arrayId );
    if( array->type == SUBARRAY ) array = array->contents.subarray.array;

    grid = array->contents.array.rowGrid;
    for( index = array->numRows; index >= 0; index-- ){
	rowCoords[ index ] = grid[ index ]->loc;
    }
    grid = array->contents.array.colGrid;
    for( index = array->numCols; index >= 0; index-- ){
	colCoords[ index ] = grid[ index ]->loc;
    }
    MK_END();
}
