/*LINTLIBRARY*/
#include "mkInternal.h"
/*
 * openSubArray()
 */
void
mkOpenSubarray( subArrayId, arrayId )
mkId *subArrayId;
mkId arrayId;
{
    s_array *array;
    s_array *subArray;
    s_arraylist *arraylist;
    mkId mk_new_id();

    MK_START( "mkOpenSubarray" );

    array = mk_get_array( arrayId );
    subArray = mk_malloc_array();
    mk_init_subarray( subArray );
    subArray->contents.subarray.array = array;
    mk_hash_array( subArray );

    arraylist = mk_malloc_arraylist();
    arraylist->array = subArray;
    arraylist->next = array->contents.array.sublist;
    array->contents.array.sublist = arraylist;

    *subArrayId = subArray->arrayId;

    MK_END();
}
