#include "defs.h"

#ifndef OCTTOOLS_COPYRIGHT_H
#define OCTTOOLS_COPYRIGHT_H
/*
 * Oct Tools Distribution 3.0
 *
 * Copyright (c) 1988, 1989, Regents of the University of California.
 * All rights reserved.
 *
 * Use and copying of this software and preparation of derivative works
 * based upon this software are permitted.  However, any distribution of
 * this software or derivative works must include the above copyright
 * notice.
 *
 * This software is made available AS IS, and neither the Electronics
 * Research Laboratory or the University of California make any
 * warranty about the software, its performance or its conformity to
 * any specification.
 *
 * Suggestions, comments, or improvements are welcome and should be
 * addressed to:
 *
 *   octtools@eros.berkeley.edu
 *   ..!ucbvax!eros!octtools
 */

#if !defined(lint) && !defined(SABER)
static char copyright[] = "Copyright (c) 1988, Regents of the University of California.  All rights reserved.";
#endif
#endif 



/*
*    Routines to insure the portability if the code
*/

strCmp( s, t )	
char *s, *t;
{
    if( (s == NIL(char)) && (t == NIL(char)) )
	return(0);
    else if( s == NIL(char) ) 
	return( -1);
    else if( t == NIL(char) ) 
	return( 1);
    else {
	for( ; *s == *t; s++, t++ ){
	    if( *s == '\0' )
		return(0);
	}
    }
    return( *s - *t );
}

strLen( s )
char *s;
{
    char *p;

    if( s == NIL(char) ) return(0);
    p = s;
    while(*p)
	p++;
    return(p-s);
}
