#include "copyright.h"
#include "port.h"
#include "defs.h"
#include "oct.h"
#include "tr.h"
#include "octRoutines.h" 


#define FOUND		1
#define CREATED		2
#define NOT_FOUND	0
#define	DELETED		1

#define MAX_NUM_POINTS  10


/*	Macro definitions	*/

#define POINT_IN_BOX( point, box) ( point->x >= box->lowerLeft.x && 		\
				  point->x <= box->upperRight.x && 		\
			       	  point->y >= box->lowerLeft.y && 		\
				  point->y <= box->upperRight.y  )


/*	Data structures		*/

struct objectList{
	octId			id;
	int			type;
	struct objectList	*nextInList;
};
