#include "octopus.h"

extern char		**GivenCore;
extern char		**Core;

allocCore(rows, cols)
int	rows, cols;
{
    int		i;

    Core = ALLOC( char *, rows );
    for( i = 0; i < rows; ++i ) {
	Core[i] = ALLOC(char, cols + 1);
	Core[ i ][ cols ] = '\0';
    }
}


allocGivenCore(rows, cols)
int	rows, cols;
{
    int		i;

    GivenCore = ALLOC( char *, rows );
    for( i = 0; i < rows; ++i ) {
	GivenCore[i] = ALLOC(char, cols + 1);
	GivenCore[ i ][ cols ] = '\0';
    }
}


freeGivenCore(rows)
int	rows;
{
    int		i;

    for( i = 0; i < rows; ++i) {
	FREE( GivenCore[i]);
    }
    FREE( GivenCore);
}


/* newInput
 * malloc and initialize a new s_input structure
 */
s_input *
newInput(name)
char	*name;
{
    s_input	*newIn;

    newIn = ALLOC( s_input, 1 );
    (void) memset((char *) newIn, 0, sizeof(s_input));
    newIn->name = util_strsav( name );
    newIn->col = -1; /* to see if its ever really used or not		*/
    return ( newIn );
}

/* newOutput
 * malloc and initialize a new s_output structure
 */
s_output *
newOutput(name)
char	*name;
{
    s_output	*newOut;

    newOut = ALLOC( s_output, 1 );
    (void) memset((char *) newOut, 0, sizeof(s_output));
    newOut->name = util_strsav( name );
    return ( newOut );
}

/* newOutput
 * malloc and initialize a new s_output structure
 */
s_inputCol *
newInputColArray(num)
int	num;
{
    s_inputCol	*newInCol;

    newInCol = ALLOC( s_inputCol, num );
    (void) memset((char *) newInCol, 0, num * sizeof(s_inputCol));
    return ( newInCol );
}
