#include "octopus.h"

extern s_arrays	Arrays;
extern s_cells	Cells;
extern s_ruleNames RuleNames;
extern s_options Options;
/*
 * wirePerimeter
 *
 * Calls mkWireArea on everything except the core
 */
wirePerimeter()
{
    if( ! Options.wire )return;
    mkWireArea( Arrays.output, mkRows( 0, 5 ), RuleNames.buffer );
    mkWireArea( Arrays.output, mkRows( 6, 11 ), RuleNames.buffer );
    mkWireArea( Arrays.orPullup, mkRow( 0 ), RuleNames.orPullup );
    mkWireArea( Arrays.orPullup, mkRow( 1 ), RuleNames.orPullup );
    mkWireArea( Arrays.orPower, mkRow( 0 ), RuleNames.cPower );
    mkWireArea( Arrays.orPower, mkRow( 1 ), RuleNames.cPower );
    mkWireArea( Arrays.vss, mkCol( 1 ), RuleNames.cPower );
    mkWireArea( Arrays.vdd, mkCol( 2 ), RuleNames.cPower );
    mkWireArea( Arrays.inPhi, mkCol( 0 ), RuleNames.cPower );
    mkWireArea( Arrays.inPhiBar, mkCol( 0 ), RuleNames.cPower );
    mkWireArea( Arrays.outPhi, mkCol( 0 ), RuleNames.cPower );
}
