#include "copyright.h"
#include "sparcs.h"
/*#include "graph.h"*/

/*
 *  Allocate the NodeArray and initialize the node pointers.  As of 7/14/86
 *  the nodes are allocated when the instances and wires are read, so set up
 *  the pointers to the nodes here.
 *
 *  7/3/85
 *  last modified 9/22/88
 */

void
allocGraph()
{
    int i;

    /*  the NodeArray  */
    NodeArray = ALLOC(struct node *, NumElements+1);
    /*
     *  Initialize the pointers.
     */
    for (i=1; i<=NumObjects; i++)  {
	NodeArray[i] = &(ElementByKey[i].ptr.po->node);
    }
    for (i=NumObjects+1; i<=NumElements; i++)  {
        NodeArray[i] = &(ElementByKey[i].ptr.pw->node);
    }
}
