#include "copyright.h"

/*
 *  Structs for instance master cacheing, used in rpc sparcs.
 *
 *  "sparcs.h" and "st.h" must be included before this file.
 *
 *  11/8/87
 *  last modified 11/13/87
 */
st_table *pMasterTable;		/* global table of masters */

struct cacheFrame  {
    struct rect box;
    struct cacheFrame *pnext;
};

struct cacheTerm  {
    int sparcsLayer;
    struct rect box;
    struct cacheTerm *pnext;
};

struct layerList  {
    int sparcsLayer;
    struct cacheFrame *pframes;
    struct layerList *pnext;
};

struct termList  {
    int termId;			/* similar to atermId of stand-alone version */
    struct cacheTerm *pterms;
    struct termList *pnext;
};

struct master  {
    struct layerList *players;
    struct termList *pterms;
};


