#include "copyright.h"

/*
 *  Structs for the virtual grid.  
 *
 *  NOTE:  must include "sparcs.h" before this file in any .c file.
 *
 *  9/29/86
 */

#define ALLOCLIST	(struct list *)malloc((unsigned)sizeof(struct list))

struct list {
    int key;
    struct list *pnext;
};

struct gridLine  {
    int loc;			/*  current location of this gridline  */
    int oldLoc;			/*  last location of this gridline     */
    int squidID;		/*  ID of SQGeo that represents line   */
    struct list *pelement;	/*  list of the layout elements on
				    this gridline		       */
    struct gridLine *pnext;	/*  gridlines are in a linked list     */
};

extern struct gridLine *pHorizontalGrid;	/*  for HORIZ. compaction,
						    so lines are VERTICAL  */
extern struct gridLine *pVerticalGrid;		/*  similar.               */
