#include "copyright.h"
#include "sparcs.h"

/*
 *  Print an edgePtr list.
 *
 *  11/3/87
 *  last modified 11/7/87
 */

/*ARGSUSED*/
void
printEdgePtrList(pedgePtrHead, verbose)
struct edgePtr *pedgePtrHead;	/* point in edgePtr list to begin printing */
int verbose;
{
    struct edgePtr *peP;
    struct edge *pe;

    for (peP=pedgePtrHead; peP!=NIL(struct edgePtr); peP=peP->pnext)  {
	printf("    coord: %d; edge: ", peP->coord);
	pe = peP->pedge;
	printf("%s, ", (pe->type == MIN) ? "MIN" : "MAX");
	printf("at %d, on %s, from obj. %d, ", pe->loc,
	       LayerMap[pe->maskNumber].name, pe->key);
	if (pe->netId == UNDEF)  {
	    printf("netId UND");
	} else  {
	    printf("netId %d", pe->netId);
	}
	printf(", masked %c\n", pe->masked);
    }
}
