#include "copyright.h"
#include "port.h"
#include "spider.h"

/*
    alloc -- allocate memory via malloc, and abort if it fails
*/
char *alloc(n, where)
int n;
char *where;
{

/*  Functions */

    char *p;

    p = CALLOC(char, n);
    if (p == NULL) {
	(void) sprintf(error, "alloc: failed allocating %d bytes for %s\n",n,where);
  	logError(error, FATAL);
    }
    return(p);
}

char *CALLOC_CHK(size,num)
int size;
unsigned num;
{

/*  Functions */


    char *p;

    p = calloc((unsigned)size, num);
    if (p == NULL) 
      {
	(void) sprintf(error, "calloc: failed allocating %u bytes\n", num);
  	logError(error, FATAL);
      }
    return(p);
}

char *mystrcpy(s)
     char *s;
{
  char *t;
  
  t = CALLOC (char,(strlen(s) + 1));
  (void) strcpy(t,s) ;
  return (t);
}
