#include "copyright.h"
#include "port.h"
#include "spider.h"

defgrid()


/**********************************************************************
 *  
 * 		  DEFGRID -- build horizental & vertical grid lines 
 * 		  -------------------------------------------------
 *
 *	---- BLDGRID sets up the following data structure. 
 *   	RC_LOC->col_loc[]
 *   	RC_LOC->col_count  
 *   	RC_LOC->col_pins[top/bottom][]  -- ptr from col to pin or NULL
 *   	pinptr->col 
 *
 *   	---- BLDGRID may modifies:
 *	pinptr->col = pinptr->netid = 0;
 *         	if the pin is too close to some other pin 
 *		(i.e., if two pins maped into same col)
 *  
 ***********************************************************************/

{

/*  Define vertical grid:  cols */

    defcol();
/*  Define horizontal channel boundary */

    defHchannel();
/*  Define horizontal grid:  rows */

    defrow();
    printf("Complete defgrid.c\n");

}
