#include "copyright.h"
#include "port.h"

/* 
 * OPEN-FILE
 */
#include "spider.h"
FILE 	*inputfile;
char	errfileName[80];
char	logfileName[80];

openFile()
{

    FILE   *fplog;
    char   inputfileName[80];

/** open .ti*  file -- the input file **/

    sprintf(inputfileName, "%s.ti%s", circuitName, channelIdname);
    inputfile = fopen(inputfileName,"r");

    if (inputfile == NULL)
    {
	printf(" error: Can't open input file %s.\n",inputfileName);
	exit(1);
    }


/** open .log  file -- the standard output **/

    sprintf(logfileName, "%s.log%s", circuitName, channelIdname);

    fplog = freopen(logfileName,"w",stdout);
    if (fplog == NULL)
    {
	printf("Can't open .log file %s\n",logfileName);
	exit(1);
    }

    /* Reconnect stdout and stderr to the .log file.
       This will allow the stdout output of YACR to
       go into the file. */

    /* Reopen stderr to be the same as stdout. */
    /* dup2(1,2); */


    printf("inputfileName: %s\n", inputfileName);
    printf("logfileName: %s\n", logfileName);
    printf("errfileName: %s\n", errfileName);
    printf("Complete openFile.c\n");
}
