typedef struct pin_struct {

	char *pinname;
	int  pintype; /* '0' - floating; '1' - relative floating; '2' - fixed;*/
	int  termid;
	int  layer;
	int  x, y;

	double  power;

	char *netname;
	int  nettype;			/* '0' - regular;  '1' - power; */
	int  netid;
	int  netwidth;

	int  cellid; /* '0' - top cell; '1' - bottom cell; '-1' - pseuedo cell*/

	int  col, row;
	int  poly_width;
	int  poly_delta;
	int  jogged;

	struct via_struct  *aterm;
	struct pin_struct  *next;

} pin_type;

typedef struct chan_pin_struct
{
 int min_x[4];
 int max_x[4];
 int min_y[4];
 int max_y[4];
 int	pinstatus;
 pin_type  *pinlist[4];  
 int  	numpins[4];
} chan_pin_type;

extern chan_pin_type *CHAN_PINS;
#define 	FIRST_PIN(side)  CHAN_PINS->pinlist[side]
