#include "PGdec.h"
#include "PGstr.h"

/* insert in the AVL tree */
/* If a new node is created it returns 1 otherwise it returns 0 */

struct node *firstnode;
struct node **ptrstack;

int numnodes;

int
InsertSNetId(nodevalue,location)
octId nodevalue;
struct node **location;
{

	struct node **tempnode;
	struct node **ptrpop();

	/* implement binary search tree for the nodes */

	if ( firstnode == NULL ) { /* the tree is empty */
		firstnode = (struct node *)calloc(1,sizeof(struct node));
		firstnode->nodename = nodevalue;
		firstnode->shape = EVEN;
		*location = firstnode;
		numnodes++;
		return ( YES );
	}

	tempnode = &firstnode;
	ptrstack = NULL;
	while ( (*tempnode) != NULL ) {
		if ( nodevalue == (*tempnode)->nodename ) {
			*location = (*tempnode);
			/* The node already exists */
			return ( NO );
		}
		else if (nodevalue < (*tempnode)->nodename) {
			/*
			ptrpush(tempnode);
			*/
			(*tempnode)->nextptr = ptrstack;
			ptrstack = tempnode;

			(*tempnode)->path = SMALL;
			if ( (*tempnode)->smallson == NULL) {
				*location = (struct node *)calloc(1,sizeof(struct node));
				(*tempnode)->smallson = *location;
				(*location)->nodename = nodevalue;
				(*location)->shape = EVEN;
				numnodes++;
				break;
			}
			else {
				tempnode = &((*tempnode)->smallson);
			}
		}
		else if (nodevalue > (*tempnode)->nodename) {
			/*
			ptrpush(tempnode);
			*/
			(*tempnode)->nextptr = ptrstack;
			ptrstack = tempnode;
			(*tempnode)->path = LARGE;
			if ( (*tempnode)->largeson == NULL) {
				*location = (struct node *)calloc(1,sizeof(struct node));
				(*tempnode)->largeson = *location;
				(*location)->nodename = nodevalue;
				(*location)->shape = EVEN;
				numnodes++;
				break;
			}
			else {
				tempnode = &((*tempnode)->largeson);
			}
		}
	}
	if ( (tempnode = ptrpop()) != NULL ) {
		if ( (*tempnode)->shape == LT && (*tempnode)->path == LARGE ) {
			(*tempnode)->shape = EVEN;
			return ( 1 );
		}
		else if ((*tempnode)->shape == RT && (*tempnode)->path == SMALL ) {
			(*tempnode)->shape = EVEN;
			return ( 1 );
		}
		else if ((*tempnode)->shape == EVEN ) {
			if ( (*tempnode)->path == SMALL ) 
				(*tempnode)->shape = LT;
			if ( (*tempnode)->path == LARGE )
				(*tempnode)->shape = RT;
		}
		else {
			FPRINTF(stderr,"PGcurrent: error in AVL tree\n");
			/*
			inorder(firstnode);
			*/
			exit(-1);
		}

		while ( (tempnode = ptrpop()) != NULL ) {
			if ((*tempnode)->shape == LT ) {
				if((*tempnode)->path == SMALL) {
					if ((*tempnode)->smallson->path == SMALL ) {
						(*tempnode)->shape = EVEN;
						(*tempnode)->smallson->shape = EVEN;
						/*
						if ( (*tempnode) == firstnode ) {
							rrotate(&firstnode);
						}
						else
						*/
						rrotate(tempnode);
						return ( 1 );
					}
					else if ((*tempnode)->smallson->path == LARGE ) {
						if ((*tempnode)->smallson->largeson->shape == LT) {
							(*tempnode)->shape = RT;
							(*tempnode)->smallson->shape = EVEN;
						}
						else if((*tempnode)->smallson->largeson->shape==RT){
							(*tempnode)->shape = EVEN;
							(*tempnode)->smallson->shape = LT;
						}
						/* the inserted node bubbles to the top: */
						else if((*tempnode)->smallson->largeson->shape==EVEN){
							if ((*tempnode)->largeson != NULL ) {
								(*tempnode)->shape = RT;
								(*tempnode)->smallson->shape = LT;
							}
							else {
								(*tempnode)->shape = EVEN;
								(*tempnode)->smallson->shape = EVEN;
							}
						}
						(*tempnode)->smallson->largeson->shape = EVEN;

						lrotate(&((*tempnode)->smallson));
						/*
						if ( (*tempnode) == firstnode ) {
							rrotate(&firstnode);
						}
						else
						*/
						rrotate(tempnode);
						return( 1 );
					}
				}
				else if((*tempnode)->path == LARGE) {
					(*tempnode)->shape = EVEN;
					return ( 1 );
				}
			}

			else if ((*tempnode)->shape == RT ) {
				if((*tempnode)->path == SMALL) {
					(*tempnode)->shape = EVEN;
					return ( 1 );
				}
				else if((*tempnode)->path == LARGE) {
					if ((*tempnode)->largeson->path == SMALL ) {
						if ((*tempnode)->largeson->smallson->shape == LT) {
							(*tempnode)->shape = EVEN;
							(*tempnode)->largeson->shape = RT;
						}
						else if((*tempnode)->largeson->smallson->shape==RT){
							(*tempnode)->shape = LT;
							(*tempnode)->largeson->shape = EVEN;
						}
						else if ((*tempnode)->largeson->smallson->shape==EVEN){
							if ((*tempnode)->smallson != NULL ) {
								(*tempnode)->shape = LT;
								(*tempnode)->largeson->shape = RT;
							}
							else {
								(*tempnode)->shape = EVEN;
								(*tempnode)->largeson->shape = EVEN;
							}
						}
						(*tempnode)->largeson->smallson->shape = EVEN;

						rrotate(&((*tempnode)->largeson));
						/*
						if ( (*tempnode) == firstnode ) {
							lrotate(&firstnode);
						}
						else
						*/
						lrotate(&(*tempnode));
						return ( 1 );
					}
					else if ((*tempnode)->largeson->path == LARGE ) {
						(*tempnode)->shape = EVEN;
						(*tempnode)->largeson->shape = EVEN;
						/*
						if ( (*tempnode) == firstnode ) {
							lrotate(&firstnode);
						}
						else
						*/
						lrotate(&(*tempnode));
						return( 1 );
					}
				}
			}
			else if ((*tempnode)->shape == EVEN ) {
				if((*tempnode)->path == SMALL) {
					(*tempnode)->shape = LT;
				}
				else if((*tempnode)->path == LARGE) {
					(*tempnode)->shape = RT;
				}
			}
		}
	}
	return (0);
}

rrotate(rootnode)
struct node **rootnode;
{
	struct node *tempptr;

	tempptr = (*rootnode)->smallson;
	(*rootnode)->smallson = tempptr->largeson;
	tempptr->largeson = *rootnode;
	*rootnode = tempptr;
}


lrotate(rootnode)
struct node **rootnode;
{
	struct node *tempptr;

	tempptr = (*rootnode)->largeson;
	(*rootnode)->largeson = tempptr->smallson;
	tempptr->smallson = *rootnode;
	*rootnode = tempptr;
}

#ifdef notdef
/* push into the stack */
ptrpush(elmptr)
struct node **elmptr;
{
	(*elmptr)->nextptr = ptrstack;
	ptrstack = elmptr;
}
#endif

struct node **ptrpop()
{
	struct node **newptr;

	if ( ptrstack == NULL )
		return ( NULL );
	else {
		newptr = ptrstack;
		ptrstack = (*ptrstack)->nextptr;
		return(newptr);
	}
}
