#include "standard.h"
int *top_row_for_this_net ;
int *bot_row_for_this_net ;
extern int pin_layers_given ;
extern FILE *fpo ;
char **pinnames ;
extern int fdthrus ;
extern int maxterm ;
extern int numnets ;

gparser( fp )
FILE *fp ;
{


int cell , term , pinctr , i , layer ;
int block , left , right , bottom , top ;
int xpos , ypos , orient ;
int from ;
double space ;
char input[1024] ;
char netname[1024] ;
NBOXPTR nptr , zapptr ;
CBOXPTR ptr ;
TEBOXPTR cptr , koptr ;


cell = 0 ;
pinctr = 0 ;
netctr = 0 ;


maketabl() ;

while(fscanf( fp , " %s " , input ) == 1 ) {

    if( strcmp( input , "cell") == 0 ) {
	cell++ ;
	(void) fscanf( fp , " %s " , input ) ;
	(void) fscanf( fp , " %s " , input ) ;
	(void) fscanf( fp , " %s " , input ) ;
	(void) fscanf( fp , " %d " , &block ) ;
    } else if( strcmp( input , "initially") == 0 ) {
	(void) fscanf( fp , " %s " , input ) ;
	(void) fscanf( fp , " %d " , &from ) ;
	(void) fscanf( fp , " %s " , input ) ;
	(void) fscanf( fp , " %s " , input ) ;
	(void) fscanf( fp , " %s " , input ) ;
	(void) fscanf( fp , " %s " , input ) ;
	(void) fscanf( fp , " %d " , &block ) ;
    } else if( strcmp( input , "nomirror") == 0 ) {
    } else if( strcmp( input , "left") == 0 ) {
	(void) fscanf( fp , " %d " , &left ) ;
	(void) fscanf( fp , " %s " , input ) ;
	(void) fscanf( fp , " %d " , &right ) ;
	(void) fscanf( fp , " %s " , input ) ;
	(void) fscanf( fp , " %d " , &bottom ) ;
	(void) fscanf( fp , " %s " , input ) ;
	(void) fscanf( fp , " %d " , &top ) ;
    } else if( strcmp( input , "pin") == 0 ) {
	(void) fscanf( fp , " %s " , input ) ; /* "name"   */
	(void) fscanf( fp , " %s " , input ) ; /* pin name */
	(void) fscanf( fp , " %s " , input ) ; /* signal   */
	(void) fscanf( fp , " %s " , input ) ; /* signal name */
	(void) strcpy( netname , input ) ;
	if( strcmp( input , "TW_PASS_THRU" ) != 0 ) {
	    pinctr++ ;
	    addhash( input ) ;
	}
	if( pin_layers_given != 0 ) {
	    (void) fscanf( fp , " %s " , input ) ; /* layer   */
	    (void) fscanf( fp , " %d " , &layer ) ; /* layer number */
	}
	(void) fscanf( fp , " %d %d " , &xpos , &ypos ) ;
    } else if( strcmp( input , "equiv") == 0 ) {
	(void) fscanf( fp , " %s " , input ) ; /* "name"   */
	(void) fscanf( fp , " %s " , input ) ; /* pin name */
	if( pin_layers_given != 0 ) {
	    (void) fscanf( fp , " %s " , input ) ; /* layer   */
	    (void) fscanf( fp , " %d " , &layer ) ; /* layer number */
	}
	(void) fscanf( fp , " %d %d " , &xpos , &ypos ) ;
	if( strcmp( netname , "TW_PASS_THRU" ) != 0 ) {
	    pinctr++ ;
	}
    } else if( strcmp( input , "unequiv") == 0 ) {
	(void) fscanf( fp , " %s " , input ) ; /* "name"   */
	(void) fscanf( fp , " %s " , input ) ; /* pin name */
	if( pin_layers_given != 0 ) {
	    (void) fscanf( fp , " %s " , input ) ; /* layer   */
	    (void) fscanf( fp , " %d " , &layer ) ; /* layer number */
	}
	(void) fscanf( fp , " %d %d " , &xpos , &ypos ) ;
	pinctr++ ;
    } else if( strcmp( input , "pad") == 0 ) {
	(void) fscanf( fp , " %s " , input ) ;
	(void) fscanf( fp , " %s " , input ) ;

	(void) fscanf( fp , " %s " , input ) ;
	(void) fscanf( fp , " %d " , &orient ) ;

	(void) fscanf( fp , " %s " , input ) ;  /* keyword padside */
	(void) fscanf( fp , " %s " , input ) ;  /* padside designation */
	(void) fscanf( fp , " %s " , input ) ;
	(void) fscanf( fp , " %d " , &left ) ;
	(void) fscanf( fp , " %s " , input ) ;
	(void) fscanf( fp , " %d " , &right ) ;
	(void) fscanf( fp , " %s " , input ) ;
	(void) fscanf( fp , " %d " , &bottom ) ;
	(void) fscanf( fp , " %s " , input ) ;
	(void) fscanf( fp , " %d " , &top ) ;
    } else if( strcmp( input , "sidespace") == 0 ) {
	(void) fscanf( fp , " %lf " , &space ) ;
    } 
}


rewind( fp ) ;

top_row_for_this_net = (int *) safe_malloc(
			(numnets + 1) * sizeof(int) ) ;
bot_row_for_this_net = (int *) safe_malloc(
			(numnets + 1) * sizeof(int) ) ;
for( i = 1 ; i <= numnets ; i++ ) {
    top_row_for_this_net[i] = -1 ;
    bot_row_for_this_net[i] = 10000000 ;
}
insert_row(1) ;
for( i = 1 ; i <= numnets ; i++ ) {
    nptr = netarray[i]->netptr ;
    for( ; nptr ; nptr = nptr->nterm ) {
	if( nptr->row > top_row_for_this_net[i] ) {
	    top_row_for_this_net[i] = nptr->row ;
	}
	if( nptr->row < bot_row_for_this_net[i] ) {
	    bot_row_for_this_net[i] = nptr->row ;
	}
    }
}

for( i = 1 ; i <= numnets ; i++ ) {
    nptr = netarray[ i ]->netptr ; 
    netarray[i]->netptr = NETNULL ;
    if( nptr != NETNULL ) {
	zapptr = nptr ;
	while( nptr->nterm != NETNULL ) {
	    nptr = nptr->nterm ;
	    FREE( zapptr ) ;
	    zapptr = nptr ;
	}
	FREE( nptr ) ;
    }
}

FREE( tearray ) ;

tearray = (NBOXPTR *) safe_malloc( (pinctr + 1 ) * sizeof( NBOXPTR ) );
for( term = 1 ; term <= pinctr ; term++ ) {
    tearray[ term ] = NETNULL ;
}
maxterm = pinctr ;
pinnames = (char **) safe_malloc( (pinctr + 1) * sizeof( char * ) ) ;

for( cell = 1 ; cell <= numcells + numterms ; cell++ ) {
    ptr = carray[cell] ;
    ptr->numterms = 0 ;
    cptr = ptr->tileptr->termsptr ;
    ptr->tileptr->termsptr = TERMNULL ;
    if( cptr != TERMNULL ) {
	koptr = cptr ;
	while( cptr->nextterm != TERMNULL ) {
	    cptr = cptr->nextterm ;
	    FREE( koptr ) ;
	    koptr = cptr ;
	}
	FREE( cptr ) ;
    }
}
return ;
}
