#include "standard.h"
extern int estimate_feeds ;
extern int tw_fast ;
extern double cost_scale_factor ;
extern unsigned randomSeed ;
extern int *nofeed ;
extern char cktName[] ;
extern int attprcel ;
extern int attmax ;
extern FILE *fpo ;
extern double T ;
extern int iteration ;
double table1[1024] , table2[1024] , table3[1024] ;
extern int addFeeds ;
extern int **pairArray ;
extern int numChans ;
extern int *maxTrack ;
extern int tracks ;
extern int doglobal ;
extern int cswaps ;
extern int stage ;
extern int noPairs ;
extern int numRows ;
extern double ckt_size_factor ;
extern double Tzero ;
extern int last_level ;
extern double finalRowControl ;
extern double initialRowControl ;
int fdthrus ;
int randVar ;

utemp()
{

double TloRange , Tfactor ; 
int pairtest , check ;
unsigned i2 ;
double **tempfile ;
char filename[1024] ;
int t , i , row , freeze ;
FILE *fp ;


last_level = -1 ;

if( stage >= 2 ) {
    pairtest = 1 ;
} else {
    pairtest = 0 ;
}
initialRowControl = 0.0 ;
finalRowControl = 0.0 ;
check = 0 ;
freeze = 10000000 ;
randVar = randomSeed ; 
fprintf( fpo, "\nThe rand generator seed was at utemp() : %d\n\n\n", 
						    randVar ) ;
 
table1[0] = 1.0 ;
table2[0] = 1.0 ;
table3[0] = 1.0 ;
for( i2 = 1 ; i2 <= 1023 ; i2++ ) {
    table1[ i2 ] = exp( -(double) i2 / 8.0 ) ;
    table2[ i2 ] = exp( -(double) i2 / 8192.0 ) ;
    table3[ i2 ] = exp( -(double) i2 / 8388608.0 ) ;
}

if( numcells <= 500 ) {
    attprcel = 25 ;
} else {
    /*  n to the 4/3 power  */
    attprcel = (int)(25.0 * 
		    pow( (double) numcells / 500.0, 1.0 / 3.0 ) ) ;
}
if( tw_fast ) {
    attprcel /= 5 ;
}

tempfile = (double **) safe_malloc( 4 * sizeof( double * ) ) ;
for( t = 0 ; t <= 3 ; t++ ) {
    tempfile[t] = (double *) safe_malloc( 2 * sizeof( double ) ) ;
}
tempfile[0][0] = 0.9825 ;
tempfile[0][1] = 90.0 ;
fprintf(fpo,"  tempfile[0][0] = %f    ", tempfile[0][0] ); 
fprintf(fpo,  "tempfile[0][1] = %f\n  ", tempfile[0][1] ); 
tempfile[1][0] = 0.915 ;
tempfile[1][1] = 20.0 ;
fprintf(fpo,"tempfile[1][0] = %f    ", tempfile[1][0] ); 
fprintf(fpo,"tempfile[1][1] = %f\n  ", tempfile[1][1] ); 
tempfile[2][0] = 0.70 ;
tempfile[2][1] = 10.0 ;
fprintf(fpo,"tempfile[2][0] = %f    ", tempfile[2][0] ); 
fprintf(fpo,"tempfile[2][1] = %f\n  ", tempfile[2][1] ); 
tempfile[3][0] = 0.10 ;
tempfile[3][1] = 0.0 ;
fprintf(fpo,"tempfile[3][0] = %f    ", tempfile[3][0] ); 
fprintf(fpo,"tempfile[3][1] = %f\n\n", tempfile[3][1] ); 


TloRange = 10000000000.0 ;
t = -1 ;

fprintf(fpo , " I    T   fds     Wire penalty P_lim errpct " ) ;
/* fprintf(fpo , "iter     T      Wire  penalty  P_lim  errpct " ) ;
*/
fprintf(fpo , "binC rowC accept  s/p early\n" ) ;
for( ; ; ) {
    while( T < TloRange ) { 
	t++ ;
	if( t > 3 ) {
	    fprintf( fpo, "exceeded tempfile array in ");
	    fprintf( fpo, "utemp.c \n");
	    exit(TW_FAIL);
	}
	Tfactor  = tempfile[t][0] ;
	TloRange = tempfile[t][1] ;
    }

    if( pairtest == 0 ) {
	uloop() ;
	if( T < Tzero ) {
	    pairtest = 1 ;
	}
	savewolf(1) ; 
    } else {
	if( check == 0 ) {
	    check = 1 ;
	    if( stage == 1 ) {
		if (numcells > 1) uloop2() ;
	    }
	    last_level = -1 ;
	    savewolf(1) ;
	    freeze = iteration ;
	    if( doglobal ) {
		sprintf( filename , "%s.cel" , cktName ) ;
		fp = twopen (filename , "r", ABORT ) ;
		finalwire() ;
		grdcell( fp ) ;
		twclose( fp ) ;
	    }
	    reassign() ;
	    if( doglobal ) {
		if( addFeeds == 0 ) {
		    for( row = 1 ; row <= numblock ; row++ ) {
			nofeed[row] = 1 ;
		    }
		}
		if( ! estimate_feeds ) {
		    findunlap(1) ;
		}
		fdthrus = findfeeds(0) ;
		fixwolf( fdthrus ) ;
		findfeeds(1) ;
		numcells += fdthrus ;
		if( stage >= 2 ) {
		    sprintf( filename , "%s.rs2" , cktName ) ;
		    if( fp = twopen ( filename , "r", NOABORT )) {
			fixfdpos(fp) ;
			twclose(fp) ;
		    }
		}
	    }
	    sortpin() ;
	    findunlap(0) ;
	    penalty = 0 ;
	    /*
	     *  This computes new wire costs for the compacted
	     *  placement (and feed insertion).  It calls unlap()
	     *  which sorts and places the cells end-to-end
	     */

	    fprintf(fpo,"Added: %d  feed-through cells\n\n",fdthrus);
	    fprintf(fpo,"Removed the cell overlaps --- ");
	    fprintf(fpo,"Will do neighbor interchanges only now\n");
	    fprintf( fpo, "\nTOTAL INTERCONNECT LENGTH: %d\n",funccost);
	    fprintf(fpo,"OVERLAP PENALTY: %d\n\n", penalty );
	    fprintf(fpo,"initialRowControl:%8.3f\n", initialRowControl);
	    fprintf(fpo,"finalRowControl:%8.3f\n", finalRowControl);
	    fflush(fpo);

	    attmax = 5 * numcells ;

	    if( stage != 3 ) {
		if( noPairs == 0 ) {
		    T = 0.001 ;
		    fprintf( fpo, "iter      T      Wire accept\n" ) ;
		    if (numcells > 1) upair() ;
		    savewolf(2) ;
		}
	    }
	} else {
	    if( noPairs == 0 ) {
		T = 0.001 ;
		if (numcells > 1) upair() ;
		savewolf(2) ;
	    }
	}
    }

    if( stage != 3 ) {
	printf("%3d ", ++iteration );
	if( iteration % 15 == 0 ) {
	    printf("\n");
	}
	fflush( stdout ) ;
    }

    if( iteration >= freeze + 3 || stage == 3 ) {
	/*
	    * WE ARE FINISHED *
	*/
	if( doglobal ) {
	    globe() ;
	    globroute() ;
	    if( cswaps ) {
		if( noPairs == 0 ) {
		    ugpair() ;
		}
	    }
	    findrchk() ;
	    fprintf(fpo,"\nFINAL NUMBER OF ROUTING TRACKS: %d\n\n", 
							    tracks ) ;
	    for( i = 1 ; i <= numChans ; i++ ) {
		fprintf(fpo,"MAX OF CHANNEL:%3d  is: %3d\n",i
						,maxTrack[i]);
	    }
	    mergplist() ;
	    outpins() ;
	    output() ; 
	} else {
	    output() ; 
	}
	fprintf(fpo,"FINAL TOTAL INTERCONNECT LENGTH: %d\n",funccost);
	fprintf(fpo,"FINAL OVERLAP PENALTY: %d    ", penalty );
	fprintf(fpo, "FINAL VALUE OF TOTAL COST IS: %d\n", 
					    funccost + penalty ) ;
	fprintf(fpo,"MAX NUMBER OF ATTEMPTED FLIPS PER T:%8d\n",attmax);
	break ;
    } else {
	T = Tfactor * T ;
    }
}
fprintf(fpo,"\n\ncost_scale_factor:%g\n\n", cost_scale_factor ) ;

return ;
}
