/*
 * counters.c: Declarations of global counters
 */
#include "port.h"
#include "utility.h"
#include "oct.h"
#include "st.h"
#include "list.h"
#include "kahlua.h"

int instanceCount = 0;		/* use to create instance names */
int netCount = 0;		/* use to create net names */
int ftermCount = 0;		/* use to create fterm names */
int pathCount = 0;		/* number of paths */
int majorNetCount = 0;		/* number of major nets */
int subcellCount = 0;		/* number of subcell instances */
int uniqueSubcellCount = 0;	/* number of unique subcell masters */
int mosfetCount = 0;		/* number of mosfet instances */
int uniqueMosfetCount = 0;	/* number of unique mosfet masters */
int contactCount = 0;		/* number of contact instances */
int uniqueContactCount = 0;	/* number of unique contact masters */
int connectorCount = 0;		/* number of connector instances */
int uniqueConnectorCount = 0;	/* number of unique connector masters */
int routeRegionCount = 0;	/* number of routing regions */

