#include "port.h"
#include "utility.h"
#include "mz.h"

mzAddEntry(x, y, list)
int x, y;
mzList **list;
{
    struct mzList *new_item;

    new_item = ALLOC(struct mzList, 1);
    new_item->position.x = x;
    new_item->position.y = y;
    new_item->next = *list;
    *list = new_item;
}


mzFree(item)
mzList *item;
{
    mzList *next;

    while (item != NIL(mzList)) {
	next = item->next;
	FREE(item);
	item = next;
    }
}

