#include "port.h"
#include "utility.h"

/*
 * nextword: Grabs next word in line and updates line
 *    returns: NULL -- if no word exists
 *             buffer -- otherwise
 */
char *nextword(ptr)
char **ptr;
{
    char *c;
    char *buffer;
    int i;

    buffer = ALLOC(char, 200);

    c = *ptr;
    while ((*c == ' ') || (*c == '\t')) {
	c++;
    }
    *ptr = c;

    if ((*c == '\n') || (*c == '\0')) {
	return NULL;
    }

    i = 0;
    while ((*c != ' ') && (*c != '\t') && (*c != '\0') && (*c != '\n')) {
	buffer[i] = *c;
	c++;
	i++;
    }
    buffer[i] = '\0';
    *ptr = c;

    return buffer;
}

