#include "copyright.h"
#include "port.h"

#include "header.h"

/*******************************************************************/

set_cell_gain(cell,part)
     pcell cell;
     int part;
{
register pnetlist nl;

  cell->part = part;
  for(nl = cell->nets;nl != NULL;nl = nl->next)
    add_net_gain(nl->net->free[part],nl->net->locked[part],nl->net->free[!part],nl->net->locked[!part],cell);


#ifdef DEBUG
  print_cell_gain(cell);
#endif
}

/*******************************************************************/

set_net_gain(from_free,from_locked,to_free,to_locked,cell,type)
pcell cell;
int type;
{

if(from_locked > 0)
  {
    if((to_locked == 0) && (to_free == 0))
      cell->gain -= type;
  }
else
  {
    if(to_locked > 0)
      {
	if(from_free <= 1)
	  cell->gain += type;
      }
    else
      {
	if((from_free <= 1) && (to_free > 0))
	  cell->gain += type;
	if(to_free < 1)
	  cell->gain -= type;
      }
  }
}

/*******************************************************************/


pcell pick_candidate(cells)
pcell cells;
{
register pcell cell;

for(cell = cells;cell != NULL;cell = cell->bucket_next)
  {
    if((cell->HLparent == TRUE) || (cell->hard_link == NULL))
      return(cell);
  }
return(NULL);
}


/*
pcell pick_candidate2(cells,level)
pcell cells;
int level;
{
register int max,g;
register pcell cell,best;

max = -P;
best = NULL;
for(cell = cells;cell != NULL;cell = cell->bucket_next)
  {
    if(cell->bucket == NULL)
      printf("ERROR\n");
    if(cell->HLparent == TRUE)
      {
	return(cell);
      }
    else
      {
	if(cell->hard_link == NULL)
	  {
	    return(cell);
	  }
      }
  }
return(best);
}
*/
