#include "port.h"
#include "oct.h"
#include "mkarray.h"
#include "utility.h"
/*
 * a test to ensure that mkarray can be linked successfully
 */
/*ARGSUSED*/
main( argc, argv )
int argc;
char *argv[];
{
    octBox *area;
    mkId id = ( mkId )0;
    octObject object;
    octCoord coords[];
    int i = 0;
    double d = 0.0;
    char *string = NIL( char );

    /* The area macros						*/
    area = mkRow( i );
    area = mkRows( i, i );
    area = mkCol( i );
    area = mkCols( i, i );
    area = mkPoint( i, i );
    area = mkIntersection( area, area );
    area = mkUnionBB( area, area );
    area = mkArrayBB( id );
    area = mkObjectBB( id, &object );
    area = mkTranslate( id, area );


    /* array management						*/
    mkOpenArray( &id, &object );
    mkOpenSubarray( &id, id );
    mkAddArrayArea( id, area );
    mkLinkSubarray( id, area, area );
    mkPlaceArray( id );
    mkFreeArray( id );
    mkAttach( id, area, &object );

    /* wiring							*/
    mkWireArea( id, area, string );
    mkNewSegment( id, &object, &object, string, i, i);
    mkCreateRule( string );
    mkAddConnectToRule( id, string, &object, &object, string, i );
    mkReadRules( id, &object );

    /* other stuff						*/
    mkGetGridCoords( id, coords, coords );
    mkSetArrayOrigin( id, 0, 0, 0 );
    mkSetArrayPitch( id, area, 0, 0 );
    mkWireIntraInstance( id, i );
    mkSetDebug( id, i );
    mkSetExpansion( id, d );
    mkSetPrintGraph( id, i );

    mkPrintSubarrayLinking( id );
    mkPrintTranslation( id, area );
}
