
#include "defs.h"
#include "sa.h"



/*
 *	linkTerm(term,term_a)
 */
linkTerm(term,term_a)
    struct termList *term,*term_a;
{
  term->next=term_a->next;
  term->prec=term_a;
  term_a->next=term;
  if (term->next!=NULL)   term->next->prec=term;
}

/*
*	unlinkTerm(term)
*/
unlinkTerm(term)
struct termList *term;

{
    /* unlink from old list **** */
    term->prec->next=term->next;
    if (term->next!=NULL) {
        term->next->prec=term->prec;
    }
}


/*
 *	linkNet(net,net_a)
 */
linkNet(net,net_a)
    struct netList *net,*net_a;
{
  net->next=net_a->next;
  net->prec=net_a;
  net_a->next=net;
  if (net->next!=NULL)   net->next->prec=net;
}

/*
*	unlinkNet(net)
*/
unlinkNet(net)
    struct netList *net;
{
  /* unlink from old list **** */
  net->prec->next=net->next;
  if (net->next!=NULL) {
    net->next->prec=net->prec;
  }
}



/*
 *	linkElt(Elt,Elt_a)
 */
linkElt(Elt,Elt_a)
    struct listElt  *Elt,*Elt_a;
{
    Elt->next=Elt_a->next;
    Elt->prec=Elt_a;
    Elt_a->next=Elt;
    if (Elt->next!=NULL)   Elt->next->prec=Elt;
}

linkEltToListHandle(handle,Elt)
    ListElt  **handle;
    ListElt  *Elt;
{
  
    Elt->next= *handle;
    Elt->prec= NULL;		/* points back to the handle */
    *handle = Elt;
    if (Elt->next!=NULL)   Elt->next->prec=Elt;
}

/*
 *	unlinkElt(Elt)
 */
unlinkElt(handle,Elt)
    ListElt  **handle;
    ListElt *Elt;
{
  
  /* unlink from old list **** */
  if (Elt->prec!=NULL) {
    Elt->prec->next=Elt->next;
  } else {			/* Elt is the first in the list. Change the handle */
    *handle = Elt->next;
  }
  if (Elt->next!=NULL) Elt->next->prec=Elt->prec; 
}

