#include "defs.h"
#include "global.h"
#include "parall.h"

	


annealVarLink(annealVar,owner,flag)
    AnnealVar	*annealVar;
    int		owner;
    int		flag;		/* add at the end or at the beginning of teh list */
{
  struct ProcessorFrame  *Proc;

  Proc = &process[owner];
  if (Proc->firstAnnealVar == NULL) {
    /*  this is the first element in the list */
    annealVar->ownerNext = NULL;
    annealVar->ownerPrec = NULL;
    Proc->firstAnnealVar = annealVar;
    Proc->lastAnnealVar  = annealVar;
  } else {
    switch (flag) {
  case FIRST:
      annealVar->ownerPrec = NULL;
      annealVar->ownerNext = Proc->firstAnnealVar;
      annealVar->ownerNext->ownerPrec = annealVar;
      Proc->firstAnnealVar = annealVar;
      break;
  case LAST:
      annealVar->ownerNext = NULL;
      annealVar->ownerPrec = Proc->lastAnnealVar;
      annealVar->ownerPrec->ownerNext = annealVar;
      Proc->lastAnnealVar = annealVar;
      break;
  default:
      FatalError("Wrong value of flag in ownerLink");
      break;
    }
  }
  Proc->curNumberOfAnnealVars++;
}



annealVarUnlink(annealVar)
    AnnealVar	*annealVar;
{
  struct ProcessorFrame  *Proc;

  Proc = &process[annealVar->owner];

  if (annealVar == Proc->firstAnnealVar) {
    Proc->firstAnnealVar = annealVar->ownerNext;
    Proc->firstAnnealVar->ownerPrec = NULL;
  } else if (annealVar == Proc->lastAnnealVar) {
    Proc->lastAnnealVar = annealVar->ownerPrec;
    Proc->lastAnnealVar->ownerNext = NULL;
  } else {
    annealVar->ownerNext->ownerPrec = annealVar->ownerPrec;
    annealVar->ownerPrec->ownerNext = annealVar->ownerNext;
  }
  Proc->curNumberOfAnnealVars--;
}
	
