#include "copyright.h"
#include "sparcs.h"
/*#include "graph.h"*/

/*
 *  Link the nodes into a list for cpm.  No allocation is needed, since
 *  buildGraph() makes sure that the nodes are present before this gets
 *  called.  From installNode() of cpm.
 *
 *  9/23/85
 *  last modified 4/8/87
 */

void
cpm_installNode(pn)
struct node *pn;
{
    if (pn == NIL(struct node))  {
	fprintf(stderr, "installNode:  NIL node pointer.\n");
	exit(100);
    }
	
    /*  check if already "installed" by seeing if is in the pNodeList  */
    if (pn->cpm.list != NIL(struct node))  return;

    /*  isn't linked yet so do it  */
    pn->cpm.list = pNodeList;
    pNodeList = pn;
    NumNodes++;
}
