#include "copyright.h"
#include "sparcs.h"
#include "st.h"
#include "cache.h"
#include "oct.h"

/*
 *  Retrieve the cached master if it exists.
 *
 *  8/2/86
 *  last modified 11/11/87
 */

struct master *
getMaster(pinst)
octObject *pinst;
{
    char buffer[BIGBUF];
    char *ptr;

    (void) sprintf(buffer, "%s/%s", pinst->contents.instance.master,
	    pinst->contents.instance.view);
    if (st_lookup(pMasterTable, buffer, &ptr) == 0) {
	return(NIL(struct master));
    } else  {
	return((struct master *) ptr);
    }
}
