#include "copyright.h"
#include "sparcs.h"
#include "oct.h"
#include "facet.h"
#include "oh.h"

/*
 *  octFlush moved here from updateOct() to facilitate finding the critical
 *  path for the direction perpendicular to the last spacing direction.
 *
 *  9/3/87
 *  last modified 9/15/87
 */

void
saveOct()
{
    if (TraceFlag)  {
        fprintf(pout, "Flushing facet %s", ohFormatName( &WorkingFacet ));
        fflush(pout);
    }

    OH_ASSERT( octFlushFacet(&WorkingFacet) );

    if (TraceFlag)  {
        fprintf(pout, "\n\n");
        fflush(pout);
    }
}
