#include "copyright.h"
#include "sparcs.h"

/*
 *  6/26/85
 *  last modified 6/23/87
 */

int
getRule(mask1, mask2, mergeable)
int mask1, mask2;	/*  mask numbers  */
char mergeable[];	/* a single character, set to 'Y' or 'N' */
{
    int rule;		/*  the rule for mask1 and mask2  */

    if (mask1<0 || mask1>NumLayers-1)  {
	fprintf(pout, "getRule:  mask number %d is illegal.\n", mask1);
	exit(-10);
    } else if (mask2<0 || mask2>NumLayers-1)  {
	fprintf(pout, "getRule:  mask number %d is illegal.\n", mask2);
	exit(-10);
    }

    /*  should just look at one triangle of the matrix, but...  */
    rule = Rules[mask1][mask2].spacing;
    *mergeable = Rules[mask1][mask2].mergeable;
    return(rule);
}
