#include "copyright.h"
#include "sparcs.h"

/*
 *  Function to print out an object.  Primarily for debugging.
 *
 *  6/12/85.
 *  last modified 10/31/87
 */

void
printObj(pobj)
struct object *pobj;
{
    if (pobj == NIL(struct object))  {
	printf("printObj:  NIL object pointer passed.\n");
	return;
    }

    printf("\nObject %d:\n", pobj->key);
    printf("\torigin is (%d, %d), upperRight corner is (%d, %d)\n",
	   pobj->origin.x, pobj->origin.y, pobj->bbUpperR.x, pobj->bbUpperR.y);
}
