#include "copyright.h"
#include "port.h"
#include "spider.h"

via_type *checkForYacrScrewUp(pin,netid,row,col,side)
pin_type *pin;
int netid,row,col,side;
{
subnet_type *subnet;
int offset;
term_type term;
via_type *via;
term_type term1,term2;
int offset_cost;
int layers_cost;
int off;

printf("YACR screw up\n");
offset = (side == TOP)?1:-1;
term.via = find_via(netid,row + offset,col - 1);
if(term.via == NULL)
  term.via = find_via(netid,row + offset,col + 1);
if(term.via != NULL)
  {
    term.via->layer1 = LAYER1;
    term.via->layer2 = LAYER1;

    term2.via = bldvia("via6", netid, 
		       RC_LOC->col_loc[col], term.via->x,
		       col, term.via->row, LAYER1, LAYER2);
	
    bldsubnet(netid, 
	      term.via->x,term.via->y,
	      term2.via->x,term2.via->y,
	      layer_width[LAYER1], LAYER1, 
	      term.via->row, term.via->col,term2.via->row, term2.via->col,
	      &term, &term2,VIA,VIA,HORIZONTAL);
    RC_LOC->boundary[side][col] += offset;

/*
    if (router_type == CHANNEL_ROUTER)  
      {
	offset_cost = 1;
	layers_cost = 1;
      }
    else
      {
	offset_cost = 1;
	layers_cost = 0;
      }	  
    off = pinOffset(pin,offset_cost,layers_cost);
*/

    return(term2.via);
  }
return(NULL);
}

not_found_error(pinptr,netid,row,col,side,type)
pin_type *pinptr;
int netid,row,col,side;
char *type;
{
subnet_type *subnet;

  printf("(%s): ERROR. no net at col %d row %d\n",type,col,row); 
  printf("layer1[][]= %d, layer2[][]= %d\n",
	 ROUTING->layer1[row][col], ROUTING->layer2[row][col]);
  printf("netname=%s, id=%d\n", pinptr->netname, netid);
  
  if (netlist[netid]->subnetlist == NULL)  
    {
      printf("(%s) no subnet for net %d\n", type, netid);
    }
  
  for (subnet=netlist[netid]->subnetlist; 
       subnet!=NULL; 
       subnet=subnet->next)  
    {
      printf(" -- subnet, col1,row1= %d %d, col2,row2= %d %d\n", 
	     subnet->col1, subnet->row1, subnet->col2 , subnet->row2);
    }
  
  printf(" -> pin->col = %d, num_rows= %d side= %d\n", pinptr->col, ROUTING->last_row, side);
  
  if (ROUTING->layer1[row][col] == netid || ROUTING->layer2[row][col] == netid)
    {
      /* software problem */
      exit(1);
    }
  else 
    {
      logError("ERROR - pin deleted from the routing -- continuing\n",NONFATAL);
      
      netlist[pinptr->netid]->numpins -= 1;
      pinptr->netid = 0;
    }
}

