#include "copyright.h"
#include "port.h"
#include "spider.h"

bldsubnet(netid, x1, y1, x2, y2, netwidth, layerid, row1, col1, row2, col2, term1, term2, term1_status, term2_status,dir)
     int     netid;
     int     x1, y1, x2, y2;
     int	netwidth;
     int	layerid;
     int row1,row2,col1,col2;
     int term1_status,term2_status;
     term_type *term1;
     term_type *term2;
     int dir;
{
  net_type     *netptr;
  subnet_type  *newnet;

/* printf("net %d --  %d %d %d %d\n",netid,row1,col1,row2,col2);  */

  netptr = netlist[netid];
  newnet = CALLOC(subnet_type, 1);
  newnet->layerid = layerid;
  newnet->x1   = x1;
  newnet->x2   = x2;
  newnet->row1   = row1;
  newnet->row2   = row2;
  newnet->y1   = y1;
  newnet->y2   = y2;
  newnet->col1   = col1;
  newnet->col2   = col2;
  newnet->dir   = dir;

  newnet->width = netwidth;
  newnet->term1_status   = term1_status;
  newnet->term2_status   = term2_status;
  if(term1 != NULL)
    {
      if(term1_status == VIA)
	{
	  newnet->term1.via   = (*term1).via;
	  add_to_subnet_list((*term1).via,newnet);
	}
      else
	  newnet->term1.pin   = (*term1).pin;
    }  
  if(term2 != NULL)
    {
      if(term2_status == VIA)
	{
	  newnet->term2.via   = (*term2).via;
	  add_to_subnet_list((*term2).via,newnet);
	}
      else
	newnet->term2.pin   = (*term2).pin;
    }
  
  newnet->next  = netptr->subnetlist;
  netptr->subnetlist = newnet;
}
