

typedef struct vertex_struct {
	int  x, y;
	int  col, row;
	struct vertex_struct  *next;
	struct vertex_struct  *prev;
} vertex_type;

typedef struct chan_bound_struct
{
  vertex_type *first[4];
  vertex_type *last[4];
  int max_x[4];
  int min_x[4];
  int max_y[4];
  int min_y[4];
  int ur_y;
  int ur_x;
} chan_bound_type;

extern chan_bound_type *CHAN_BOUND;
extern vertex_type *grid_chan_boundary[2];


vertex_type *new_vertex();
vertex_type *relink_boundary();
vertex_type *relink_boundary2();
