#include "copyright.h"
#include "port.h"
#include "spider.h"
via_type	*vialist;

defcontacts(routing)
routing_type *routing;

/**************************************************************
 *
 *  defcontacts finds the places in the channel where layerOne is to
 *  be connected to layerTwo, this does not include layer changes that
 *  may be needed to connected to pins along the edges of the channel.
 *
 *  A contact is placed at every i,j where layerOne[i][j] = layerTwo[i][j].  
 *
 *****************************************************************/

{
    char	vianame[80];
    int 	col, row;
    int 	netid;

    vialist = NULL;

    FOREACH_ROW(routing, row)
      FOREACH_COL(routing, col)
	{
	  if ((routing->layer1[row][col] == routing->layer2[row][col]) && 
	      (routing->layer1[row][col] != 0))
	    {
	      netid = routing->layer1[row][col];
	      bldvia("via", netid, 0,0, col,row, LAYER1, LAYER2);
	    }
	}
    printf("Complete defcontacts.c\n");
}
