#include "copyright.h"
#include "port.h"

/*
	ACTUALLY COMPUTE THE CHANNEL DENSITY 

*/
#include "spider.h"
#define insert_in_pin_list(pl,list) \
  pl->next = list; \
  list = pl;

int *col_den;
#define CHAN 0
#define DEN 1
int *chan_break_den[2];

ppin_list in_pin_list();

ppin_list new_pin_list(pin)
pin_type *pin;
{
ppin_list pl;

pl = CALLOC(struct pin_list,1);
pl->pin = pin;
pl->left[TOP] = pl->left[BOTTOM] = MAXINT;
pl->right[TOP] = pl->right[BOTTOM] = MININT;
return(pl);
}

update_right(ppl,side, loc)
ppin_list ppl;
int side,loc;
{
ppl->r_loc = loc;
ppl->right[side] = loc;
if(ppl->left[side] == 0)
  ppl->left[side] = loc;
}


ppin_list set_up_density(t_offset,b_offset)
int t_offset,b_offset;
{
int col;
ppin_list pins,ppl;
pin_type *pin;
int lim,i;
int side;

printf("(set_up_density): offsets %d %d\n",t_offset,b_offset);
col_den   = CALLOC( int, 3 * RC_LOC->col_count + 10);
for(i = 0;i < 3 * RC_LOC->col_count + 10;i++)
  col_den[i] = 0;
col_den = &(col_den[(3 * RC_LOC->col_count / 2) + 5]);

if(t_offset == 0)
  side = TOP;
else
  side = BOTTOM;

pins = NULL;

for(pin = FIRST_PIN(LEFT);pin != NULL;pin = pin->next)
  {
    ppl = new_pin_list(pin);
    insert_in_pin_list(ppl,pins);
    ppl->left[side] = MININT;
  }  
for(col = 1;col <= RC_LOC->col_count;col++)
  {
    if(RC_LOC->col_pins[TOP][col] != NULL)
      {
	if((ppl = in_pin_list(pins,RC_LOC->col_pins[TOP][col])) != NULL)
	  {
	    if(ppl->left[TOP] > col + t_offset)
	      ppl->left[TOP] = col + t_offset;
	    if(ppl->right[TOP] < col + t_offset)
	      ppl->right[TOP] = col + t_offset;
	  }
	else
	  {
	    ppl = new_pin_list(RC_LOC->col_pins[TOP][col]);
	    insert_in_pin_list(ppl,pins);
	    ppl->left[TOP] = col + t_offset;
	    ppl->right[TOP] = col + t_offset;
	  }
      }
  }
for(col = 1;col <= RC_LOC->col_count;col++)
  {
    if(RC_LOC->col_pins[BOTTOM][col] != NULL)
      {
	if((ppl = in_pin_list(pins,RC_LOC->col_pins[BOTTOM][col])) != NULL)
	  {
	    if(ppl->left[BOTTOM] > col + b_offset)
	      ppl->left[BOTTOM] = col + b_offset;
	    if(ppl->right[BOTTOM] < col + b_offset)
	      ppl->right[BOTTOM] = col+ b_offset;
	  }
	else
	  {
	    ppl = new_pin_list(RC_LOC->col_pins[BOTTOM][col]);
	    insert_in_pin_list(ppl,pins);
	    ppl->left[BOTTOM] = col + b_offset;
	    ppl->right[BOTTOM] = col + b_offset;
	  }
      }
  }

for(pin = FIRST_PIN(RIGHT);pin != NULL;pin = pin->next)
  if((ppl = in_pin_list(pins,pin)) != NULL)
    {
      ppl->right[side] = MAXINT;
    }  
  else
    printf("(den2): ERROR in computing density\n");

for(ppl = pins;ppl != NULL;ppl = ppl->next)
  {
    lim = MIN(3 * RC_LOC->col_count / 2,MAX(ppl->right[TOP],ppl->right[BOTTOM]));
    col = MAX(-3 * RC_LOC->col_count / 2,MIN(ppl->left[TOP],ppl->left[BOTTOM]));
    if(col != lim)
      for(;col <= lim;col++)
	col_den[col]++;
  }
/*
for(ppl = pins;ppl != NULL;ppl = ppl->next)
  printf("pin %s spans %d to %d ===== %d %d  %d %d\n",ppl->pin->netname,ppl->l_loc,ppl->r_loc,ppl->left[TOP],ppl->right[TOP],ppl->left[BOTTOM],ppl->right[BOTTOM]);
print_density_off();
*/
printf("Complete den2.c\n");
return(pins);
}


ppin_list in_pin_list(list,pin)
ppin_list list;
pin_type *pin;
{
for(;list != NULL;list = list->next)
  if(list->pin->netid == pin->netid)
    break;
return(list);
}


break_up_channel2()
{
vertex_type *tvert,*bvert;
int i,seg,l_col;

for(i = 0,tvert = CHAN_BOUND->first[TOP];tvert != NULL;tvert = tvert->next)
  {
    i++;
    printf("top %d\n",tvert->x);
  }
for(bvert = CHAN_BOUND->first[BOTTOM];bvert != NULL;bvert = bvert->next)
  {
    i++;
    printf("bot %d\n",bvert->x);
  }

chan_break_den[CHAN] = CALLOC(int,i+1);
chan_break_den[DEN] = CALLOC(int,i+1);

tvert = CHAN_BOUND->first[TOP];
bvert = CHAN_BOUND->first[BOTTOM];

seg = 0;
if(tvert->x != bvert->x)
  {
    printf("channel segments -- %d to %d\n",MIN(tvert->x,bvert->x),MAX(tvert->x,bvert->x));
    chan_break_den[CHAN][seg] = MIN(tvert->x,bvert->x);
    chan_break_den[DEN][seg++] = get_chan_seg_den(MIN(tvert->x,bvert->x),MAX(tvert->x,bvert->x));
    }
while((tvert != NULL) && (bvert != NULL))
  {
    printf("channel segments -- %d to ",MAX(tvert->x,bvert->x));
    l_col = MAX(tvert->x,bvert->x);
    chan_break_den[CHAN][seg] = l_col;
    
    if(tvert->next->x < bvert->next->x)
      {
	printf("%d\n",tvert->next->x);
	chan_break_den[DEN][seg++] = get_chan_seg_den(l_col,tvert->next->x);
	tvert = tvert->next;
	if((tvert != NULL) && (tvert->next == NULL))
	  break;
	tvert = tvert->next;
      }
    else
      {
	printf("%d\n",bvert->next->x);
	chan_break_den[DEN][seg++] = get_chan_seg_den(l_col,bvert->next->x);
	bvert = bvert->next;
	if((bvert != NULL) && (bvert->next == NULL))
	  break;
	bvert = bvert->next;
      }
  }
if(tvert->next == NULL)
  {
    if(bvert->next == NULL)
      printf("ERROR in breaking channel\n");
    else
      {
	printf("channel segments -- %d to %d\n",tvert->x,bvert->next->x);
	chan_break_den[CHAN][seg] = tvert->x;
	chan_break_den[DEN][seg++] = get_chan_seg_den(tvert->x,bvert->next->x);
	chan_break_den[CHAN][seg] = bvert->next->x;
	chan_break_den[DEN][seg] = chan_break_den[DEN][seg-1];
      }
  }
else
  {
    if(tvert->next == NULL)
      printf("ERROR in breaking channel\n");
    else
      {
	printf("channel segments -- %d to %d\n",bvert->x,tvert->next->x);
	chan_break_den[CHAN][seg] = bvert->x;
	chan_break_den[DEN][seg++] = get_chan_seg_den(bvert->x,tvert->next->x);
	chan_break_den[CHAN][seg] = tvert->next->x;
	chan_break_den[DEN][seg] = chan_break_den[DEN][seg-1];
      }
  }
for(i = 0;i <= seg;i++)
  printf("break %d den %d\n",chan_break_den[CHAN][i],chan_break_den[DEN][i]);
}


closest_col(num)
int num;
{
int col;

for(col = 1;(col <= RC_LOC->col_count) && (RC_LOC->col_loc[col] < num);col++)
  {}
if(col == 1)
  return(1);
if(RC_LOC->col_loc[col] != num)
  {
    if(num - RC_LOC->col_loc[col- 1] < RC_LOC->col_loc[col] - num)
      return(col - 1);
    else
      return(col);
  }
return(col);
}


get_chan_seg_den(l,r)
int l,r;
{

if(r < RC_LOC->col_loc[1])
  {
    if(FIRST_PIN(LEFT) == NULL)
      return(0);
    else
      return(col_den[1]);
  }
if(l > RC_LOC->col_loc[RC_LOC->col_count])
  {
    if(FIRST_PIN(RIGHT) == NULL)
      return(0);
    else
      return(col_den[RC_LOC->col_count]);
  }

return(max_den_in_range(closest_col(l),closest_col(r)));
}

max_den_in_range(l,r)
int l,r;
{
int max;

max = MININT;
for(;l <= r;l++)
  if(col_den[l] > max)
    max = col_den[l];
return(max);
}

break_up_channel()
{
vertex_type *tvert;
int i;
int side;

for(side = TOP;side <= BOTTOM;side++)
  {
    for(i = 0,tvert = CHAN_BOUND->first[side];tvert != NULL;tvert = tvert->next)
      {
	i++;
      }
    chan_break_den[side] = CALLOC(int,i+1);
    for(i=0,tvert = CHAN_BOUND->first[side];(tvert != NULL) && (tvert->next != NULL);tvert = tvert->next->next,i++)
      {
	chan_break_den[side][i] = get_chan_seg_den(tvert->x,tvert->next->x);
	printf("density %d to %d = %d\n",tvert->x,tvert->next->x,chan_break_den[side][i]);
      }
  }
}

