#include "copyright.h"
#include "port.h"
#include "spider.h"
int ADJUST = FALSE;
extern int CHANNEL_WIDTH;

moveCellVert(side,delt_row)
int side;
int delt_row;
{
int		delt_y;

if(side == TOP)
  updateJoggedPins(TOP, delt_row);

delt_y = delt_row * GRIDHEIGHT;

printf("cell moved vertically by %d units\n",delt_y);

CHANNEL_WIDTH += delt_y;

         /*  Ajust channel location */

move_bound(side, delt_y);
move_RC_LOC_bound(side,delt_row);
}

moveCellHor(side,off)
int side,off;
{
pin_type *pinptr;
int adj_x;
vertex_type *vert,*ptr;


printf("cell moved horizontally by %d columns\n",off);
if(off == 0)
  return;
adj_x = RC_LOC->col_loc[FIRST_PIN(side)->col + off] - RC_LOC->col_loc[FIRST_PIN(side)->col];
for(vert = CHAN_BOUND->first[side];vert != NULL;vert = vert->next)
  vert->x += adj_x;
for(ptr = grid_chan_boundary[side];(ptr != NULL);ptr = ptr->next)
  ptr->x += adj_x;

for (pinptr=FIRST_PIN(side); pinptr!=NULL; pinptr=pinptr->next) 
  {
    pinptr->x += adj_x;
  }

/* adjust global vars */

if(off > 0)
  CHAN_BOUND->ur_x  += adj_x;

CELL_LIST[side]->x += adj_x;
CHAN_PINS->min_x[side] += adj_x;
CHAN_PINS->max_x[side] += adj_x;
CHAN_BOUND->min_x[side] += adj_x;
CHAN_BOUND->max_x[side] += adj_x;
if(off < 0)
  {
    CHAN_BOUND->min_x[LEFT] = MIN(CHAN_BOUND->min_x[side],CHAN_BOUND->min_x[LEFT]);
    CHAN_BOUND->max_x[LEFT] = MIN(CHAN_BOUND->min_x[side],CHAN_BOUND->max_x[LEFT]);
  }
else
  {
    CHAN_BOUND->min_x[RIGHT] = MAX(CHAN_BOUND->min_x[side],CHAN_BOUND->min_x[RIGHT]);
    CHAN_BOUND->max_x[RIGHT] = MAX(CHAN_BOUND->min_x[side],CHAN_BOUND->max_x[RIGHT]);
  }

}

moveCellHorLAMBDA(side,adj_x)
int side,adj_x;
{
pin_type *pinptr;
vertex_type *vert,*ptr;


printf("cell moved horizontally by %d lambda\n",adj_x);
if(adj_x == 0)
  return;

adj_x = adj_x * 20;
for(vert = CHAN_BOUND->first[side];vert != NULL;vert = vert->next)
  vert->x += adj_x;
for(ptr = grid_chan_boundary[side];(ptr != NULL);ptr = ptr->next)
  ptr->x += adj_x;

for (pinptr=FIRST_PIN(side); pinptr!=NULL; pinptr=pinptr->next) 
  {
    pinptr->x += adj_x;
  }

/* adjust global vars */

if(adj_x > 0)
  CHAN_BOUND->ur_x  += adj_x;

CELL_LIST[side]->x += adj_x;
CHAN_PINS->min_x[side] += adj_x;
CHAN_PINS->max_x[side] += adj_x;
CHAN_BOUND->min_x[side] += adj_x;
CHAN_BOUND->max_x[side] += adj_x;
if(adj_x < 0)
  {
    CHAN_BOUND->min_x[LEFT] = MIN(CHAN_BOUND->min_x[side],CHAN_BOUND->min_x[LEFT]);
    CHAN_BOUND->max_x[LEFT] = MIN(CHAN_BOUND->min_x[side],CHAN_BOUND->max_x[LEFT]);
  }
else
  {
    CHAN_BOUND->min_x[RIGHT] = MAX(CHAN_BOUND->min_x[side],CHAN_BOUND->min_x[RIGHT]);
    CHAN_BOUND->max_x[RIGHT] = MAX(CHAN_BOUND->min_x[side],CHAN_BOUND->max_x[RIGHT]);
  }

}
