#include "copyright.h"
#include "port.h"


  /* compute the corners of the mighty channel boundary */
#include "spider.h"
vertex_type *grid_chan_boundary[2];

newcorner()
{
  int 	coli, rowi;
  int 	colj, rowj;

  vertex_type *ptr;
  vertex_type *vertex;
  
    coli = 1;
    rowi = RC_LOC->boundary[TOP][1];
    vertex = new_vertex();
    vertex->x = coli;
    vertex->y = rowi;
    grid_chan_boundary[TOP] = ptr = vertex;
    num_corners[TOP] = 1;
    
    for (colj=2;  colj<=RC_LOC->col_count;  colj++)  
      {
	rowj = RC_LOC->boundary[TOP][colj];
	
	if (rowj < rowi)  
	  {
	    vertex = new_vertex();
	    vertex->x = colj;
	    vertex->y = rowi;
	    ptr->next = vertex;
	    ptr = vertex;
	    
	    vertex = new_vertex();
	    vertex->x = colj;
	    vertex->y = rowj;
	    ptr->next = vertex;
	    ptr = vertex;
	    
	    num_corners[TOP] +=2;
	    
	    coli = colj;
	    rowi = rowj;
	  }
	else
	  if (rowj > rowi)  
	    {
	      vertex = new_vertex();
	      vertex->x = colj - 1;
	      vertex->y = rowi;
	      ptr->next = vertex;
	      ptr = vertex;
	      
	      vertex = new_vertex();
	      vertex->x = colj - 1;
	      vertex->y = rowj;
	      ptr->next = vertex;
	      ptr = vertex;
	      
	      num_corners[TOP] +=2;
	      
	      coli = colj - 1;
	      rowi = rowj;
	    }
      }
    if (coli < RC_LOC->col_count)  
      {
	vertex = new_vertex();
	vertex->x = RC_LOC->col_count;
	vertex->y = rowi;
	ptr->next = vertex;
	ptr = vertex;
	ptr->next = NULL;
	
	num_corners[TOP]++;
      }

  coli = 1;
  rowi = RC_LOC->boundary[BOTTOM][1];
  
  vertex = new_vertex();
  vertex->x = coli;
  vertex->y = rowi;
  grid_chan_boundary[BOTTOM] = ptr = vertex;
  
  num_corners[BOTTOM] = 1;

  for (colj=2;  colj<=RC_LOC->col_count;  colj++)  
    {
      
      rowj = RC_LOC->boundary[BOTTOM][colj];
      
      if (rowj < rowi)  
	{
	  
	  vertex = new_vertex();
	  vertex->x = colj - 1;
	  vertex->y = rowi;
	  ptr->next = vertex;
	  ptr = vertex;
	  
	  vertex = new_vertex();
	  vertex->x = colj - 1;
	  vertex->y = rowj;
	  ptr->next = vertex;
	  ptr = vertex;
	  
	  num_corners[BOTTOM] +=2;
	  
	  coli = colj - 1;
	  rowi = rowj;
	}
      else if (rowj > rowi)  
	{
	  
	  vertex = new_vertex();
	  vertex->x = colj;
	  vertex->y = rowi;
	  ptr->next = vertex;
	  ptr = vertex;
	  
	  vertex = new_vertex();
	  vertex->x = colj;
	  vertex->y = rowj;
	  ptr->next = vertex;
	  ptr = vertex;
	  
	  num_corners[BOTTOM] +=2;
	  
	  coli = colj;
	  rowi = rowj;
	}
    }
  if (coli < RC_LOC->col_count)  
    {
      vertex = new_vertex();
      vertex->x = RC_LOC->col_count;
      vertex->y = rowi;
      ptr->next = vertex;
      ptr = vertex;
      ptr->next = NULL;
      
      num_corners[BOTTOM]++;
    }

  printf("(newcorner): top,btm #_corner = %d %d\n",
	 num_corners[TOP],num_corners[BOTTOM]);

/*
  {
    int side;
    for(side = TOP;side <= BOTTOM;side++)
      {
	for(ptr = grid_chan_boundary[side];ptr != NULL;ptr = ptr->next)
	  {
	    printf("new corner -- side %d -- %d %d\n",side,ptr->x,ptr->y);
	  }
      }
  }
*/
}

