#include "copyright.h"
#include "port.h"
#include "spider.h"

chan_pin_type *CHAN_PINS;

subnet_type *find_connecting_subnet(pin, side)
pin_type *pin;
int side;
{
int row,col;
subnet_type *sub, *subnet;
term_type term;

col = pin->col;
row = get_row(side,pin);
sub = NULL;
for (subnet=netlist[pin->netid]->subnetlist; 
     subnet!=NULL; 
     subnet=subnet->next)  
  {
    if ((col == subnet->col1 && row == subnet->row1)  ||
	(col == subnet->col2 && row == subnet->row2)) 
      {
	if(sub == NULL)
	  sub = subnet;
	else
	  {
	    if(subnet->dir == VERTICAL)
	      sub = subnet;
	  }
      }
  }

if (sub == NULL)  
  {
    if(netlist[pin->netid]->subnetlist == NULL)
      if(col == RC_LOC->col_count)
	{
	  printf("WARNING -- naked wire found\n");
	}
    if((term.via = checkForYacrScrewUp(pin,pin->netid,row,col,side)) == NULL)
      {
	not_found_error(pin,pin->netid,row,col,side,"adjustVnet2a");
	return(NULL);
      }
    else
      {
	for (subnet=netlist[pin->netid]->subnetlist; 
	     subnet!=NULL; 
	     subnet=subnet->next)  
	  {
	    if (((term.via->col == subnet->col1) && 
		 (term.via->row == subnet->row1))  ||
		((term.via->col == subnet->col2) && 
		 (term.via->row == subnet->row2)))
	      {
		if(sub == NULL)
		  sub = subnet;
		else
		  {
		    if(subnet->dir == VERTICAL)
		      sub = subnet;
		  }
	      }
	  }
      }
  }
return(sub);
}
