#include "copyright.h"
#include "port.h"
#include "spider.h"

push_nets_back()
{
int col,dir,i,j;
vertex_type *last_top,*last_bot;

for(col = 1;(col < RC_LOC->col_count) && (RC_LOC->col_loc[col] < CHAN_BOUND->min_x[RIGHT]);col++)
  {}
for(last_top = CHAN_BOUND->first[TOP];last_top->next != NULL;last_top = last_top->next)
  {}
for(last_bot = CHAN_BOUND->first[BOTTOM];last_bot->next != NULL;last_bot = last_bot->next)
  {}
if(last_top->x < last_bot->x)
  dir = BOTTOM;
else
  dir = TOP;

if(dir == TOP)
  {
    FOREACH_ROW(ROUTING, i)
      {
	for(j = RC_LOC->col_count - 1;(j >= col) && 
	    (ROUTING->layer1[i][j] == 0) && 
	    (ROUTING->layer2[i][j] == ROUTING->layer1[i][RC_LOC->col_count]) &&
	    ((ROUTING->layer1[i][RC_LOC->col_count] == 0) || 
	     (((RC_LOC->col_pins[TOP][j] == NULL) || 
	       (RC_LOC->col_pins[TOP][j]->netid != ROUTING->layer1[i][RC_LOC->col_count])) &&
	      ((RC_LOC->col_pins[BOTTOM][j] == NULL) || 
	       (RC_LOC->col_pins[BOTTOM][j]->netid != ROUTING->layer1[i][RC_LOC->col_count]))));
	    j--)
	  {}
	if(j >= col)
	  col = j + 1;
	if((col < RC_LOC->col_count) && ((ROUTING->layer1[i][RC_LOC->col_count] != 0) || (ROUTING->layer2[i][RC_LOC->col_count] != 0)))
	  shorten_wire(ROUTING->layer2[i][RC_LOC->col_count],RIGHT,i,RC_LOC->col_count,col);
      }
  }
else
  {
    FOREACH_ROW_REVERSE(ROUTING, i)
      {
	for(j = RC_LOC->col_count - 1;(j >= col) && 
	    (ROUTING->layer1[i][j] == 0) &&
	    (ROUTING->layer2[i][j] == ROUTING->layer1[i][RC_LOC->col_count]) &&
	    ((ROUTING->layer1[i][RC_LOC->col_count] == 0) || 
	     (((RC_LOC->col_pins[TOP][j] == NULL) || 
	       (RC_LOC->col_pins[TOP][j]->netid != ROUTING->layer1[i][RC_LOC->col_count])) &&
	      ((RC_LOC->col_pins[BOTTOM][j] == NULL) || 
	       (RC_LOC->col_pins[BOTTOM][j]->netid != ROUTING->layer1[i][RC_LOC->col_count]))));
	    j--)
	  {}
	if(j >= col)
	  col = j + 1;
	if((col < RC_LOC->col_count) && ((ROUTING->layer1[i][RC_LOC->col_count] != 0) || (ROUTING->layer2[i][RC_LOC->col_count] != 0)))
	  shorten_wire(ROUTING->layer2[i][RC_LOC->col_count],RIGHT,i,RC_LOC->col_count,col);
      }
  }


for(col = RC_LOC->col_count;(col > 1) && (RC_LOC->col_loc[col] > CHAN_BOUND->max_x[LEFT]);col--)
  {}
if(CHAN_BOUND->first[TOP]->x > CHAN_BOUND->first[BOTTOM]->x)
  dir = BOTTOM;
else
  dir = TOP;

if(dir == TOP)
  {
    FOREACH_ROW(ROUTING, i)
      {
	for(j = 2;(j <= col) && 
	    (ROUTING->layer1[i][j] == 0) &&
	    (ROUTING->layer2[i][j] == ROUTING->layer1[i][1]) &&
	    ((ROUTING->layer1[i][1] == 0) || 
	     (((RC_LOC->col_pins[TOP][j] == NULL) || 
	       (RC_LOC->col_pins[TOP][j]->netid != ROUTING->layer1[i][1])) &&
	      ((RC_LOC->col_pins[BOTTOM][j] == NULL) || 
	       (RC_LOC->col_pins[BOTTOM][j]->netid != ROUTING->layer1[i][1]))));
	    j++)
	  {}
	if(j <= col)
	  col = j - 1;
	if((col > 1) && ((ROUTING->layer1[i][1] != 0) || (ROUTING->layer2[i][1] != 0)))
	  shorten_wire(ROUTING->layer2[i][1],LEFT,i,1,col);
      }
  }
else
  {
    FOREACH_ROW_REVERSE(ROUTING, i)
      {
	for(j = 2;(j <= col) && 
	    (ROUTING->layer1[i][j] == 0) &&
	    (ROUTING->layer2[i][j] == ROUTING->layer1[i][1]) &&
	    ((ROUTING->layer1[i][1] == 0) || 
	     (((RC_LOC->col_pins[TOP][j] == NULL) || 
	       (RC_LOC->col_pins[TOP][j]->netid != ROUTING->layer1[i][1])) &&
	      ((RC_LOC->col_pins[BOTTOM][j] == NULL) || 
	       (RC_LOC->col_pins[BOTTOM][j]->netid != ROUTING->layer1[i][1]))));
	    j++)
	  {}
	if(j <= col)
	  col = j - 1;
	if((col > 1) && ((ROUTING->layer1[i][1] != 0) || (ROUTING->layer2[i][1] != 0)))
	  shorten_wire(ROUTING->layer2[i][1],LEFT,i,1,col);
      }
  }

}


shorten_wire(netid,side,row,old_col,col)
int netid,side,row,old_col,col;
{
subnet_type *subnet;
pin_type *pin;

for (pin = FIRST_PIN(side);(pin != NULL) && (netid != pin->netid); pin = pin->next) 
  {}
if(pin != NULL)
  {
    printf("(push:)shorten wire %d by %d at row %d from col %d to col %d\n",netid,RC_LOC->col_loc[old_col] - RC_LOC->col_loc[col],row,old_col,col);
    pin->x = RC_LOC->col_loc[col];
    for (subnet = netlist[netid]->subnetlist;subnet!= NULL;subnet =  subnet->next)
      {
	if (subnet->col1 == old_col  &&  subnet->row1 == row)  
	  {
	    subnet->term1.via->x = subnet->x1 = RC_LOC->col_loc[col];
	    break;
	  }
	
	if (subnet->col2 == old_col  &&  subnet->row2 == row)  
	  {
	    subnet->term2.via->x = subnet->x2 = RC_LOC->col_loc[col];
	    break;
	  }
      }
  }
}


