#include "copyright.h"
#include "port.h"
#include "spider.h"

int **read_layer(fp, routing)
FILE *fp;
routing_type *routing;
{
    extern char *alloc();
    int 	i, j, **layer;
    int  netid;

    		/* add 2 rows for a blank border */
    layer = (int **) alloc((NUM_ROWS(routing) + 2) * sizeof(int *), "read_layer");
    for(i = FIRST_ROW(routing);i <= LAST_ROW(routing) + 2;i++)
      {
	layer[i] = (int *) alloc((NUM_COLS(routing) + 2) * sizeof(int), "read_layer");
	for(j = FIRST_COL(routing);j <= LAST_COL(routing) + 2;j++)
	  layer[i][j] = 0;
      }
    layer = &(layer[1]); /* to center boundary */

    /* Read the router output file */

    for(i = LAST_ROW(routing);i >= FIRST_ROW(routing) + YACR_ROW_OFFSET;i--)
      {
	FOREACH_COL(routing, j)
	  {
	    if (fscanf(fp, "%d", &netid) != 1)
	      logError("read_router_file: problem reading layer", FATAL);
	    layer[i][j] = netid;
	  }
      }
    return(layer);
}
