#include "copyright.h"
#include "port.h"
#include "spider.h"

routing_type *ROUTING;

set_up_matrix(fp, rows, cols)
FILE *fp;
int rows;
int cols;
{

ROUTING = CALLOC(routing_type, 1);

ROUTING->first_col = 0;
ROUTING->first_row = 0;
ROUTING->last_col = cols;
ROUTING->last_row = rows - 1 + YACR_ROW_OFFSET;
ROUTING->layer2 = read_layer(fp, ROUTING);
ROUTING->layer1 = read_layer(fp, ROUTING);
}


print_layers()
{
int i,j;

FOREACH_ROW_REVERSE(ROUTING, i)
  {
    for(j = ROUTING->first_col;j <= ROUTING->last_col;j++)
      {
	printf("%d ",ROUTING->layer1[i][j]);
      }
    printf("\n");
  }

printf("\n");
FOREACH_ROW_REVERSE(ROUTING, i)
  {
    for(j = ROUTING->first_col;j <= ROUTING->last_col;j++)
      {
	printf("%d ",ROUTING->layer2[i][j]);
      }
    printf("\n");
  }
}
