

typedef struct routing_struct
{
  int **layer1;
  int **layer2;
  int first_col;
  int first_row;
  int last_col;
  int last_row;
}  routing_type;

extern routing_type *ROUTING;

#define LAST_ROW(routing)  ((routing)->last_row)
#define FIRST_ROW(routing)  ((routing)->first_row)
#define NUM_ROWS(routing)  (LAST_ROW(routing) - FIRST_ROW(routing) + 1)
#define NUM_COLS(routing)  (LAST_COL(routing) - FIRST_COL(routing) + 1)

#define LAST_COL(routing)  ((routing)->last_col)
#define FIRST_COL(routing)  ((routing)->first_col)
#define NUM_COLS(routing)  (LAST_COL(routing) - FIRST_COL(routing) + 1)

#define FOREACH_ROW(routing, row) \
      for ((row)=FIRST_ROW(routing); (row) <= LAST_ROW(routing); (row)++)  

#define FOREACH_ROW_REVERSE(routing, row) \
    for((row) = LAST_ROW(routing);(row) >= FIRST_ROW(routing);(row)--)

#define FOREACH_COL(routing, col) \
      for ((col) = FIRST_COL(routing) + 1; (col) <= LAST_COL(routing); (col)++)
