#include "copyright.h"
#include "port.h"
#include "spider.h"

int num_rows, num_cols;

setmatrix()

/***********************************************************
 *
 **********************************************************/

{

/*  Functions */
extern char *alloc();


    int  netid;
    int  layer;

    int  col1,			/* lower left x coord of rectangle */
	 row1,			/* lower left y coord of rectangle */
	 col2,			/* upper right x coord of rectangle */
	 row2;			/* upper right y coord of rectangle */
    int  col,row;		/* loop counters */
    int i, j;
    int  debug;

    subnet_type *subnet;
    via_type    *via;

    debug = 0;

/* Dynamically allocate the array for storing the routing matrix */

/* add 2 rows for a blank border */
ROUTING->layer1 = CALLOC(int *,NUM_ROWS(ROUTING) + 2);
for(i = FIRST_ROW(ROUTING);i <= LAST_ROW(ROUTING) + 2;i++)
  {
    ROUTING->layer1[i] = CALLOC(int, NUM_COLS(ROUTING) + 2);
    for(j = FIRST_COL(ROUTING);j <= LAST_COL(ROUTING) + 2;j++)
      ROUTING->layer1[i][j] = 0;
  }
ROUTING->layer1 = &(ROUTING->layer1[1]); /* to center boundary */

/* add 2 rows for a blank border */
ROUTING->layer2 = CALLOC(int *, NUM_ROWS(ROUTING) + 2);
for(i = FIRST_ROW(ROUTING);i <= LAST_ROW(ROUTING) + 2;i++)
  {
    ROUTING->layer2[i] = CALLOC(int, NUM_COLS(ROUTING) + 2);
    for(j = FIRST_COL(ROUTING);j <= LAST_COL(ROUTING) + 2;j++)
      ROUTING->layer2[i][j] = 0;
  }
ROUTING->layer2 = &(ROUTING->layer2[1]); /* to center boundary */

for (netid=1;  netid <= net_count;  netid++) 
  {
    for (subnet=netlist[netid]->subnetlist;  
	 subnet!=NULL;  
	 subnet=subnet->next)  
      {
	col1 = subnet->col1;
	row1 = subnet->row1;
	col2 = subnet->col2;
	row2 = subnet->row2;
	layer = subnet->layerid;

/*
	printf("set mat %d %d %d %d  lay %d\n",row1, col1, row2, col2,layer);
*/

	if (layer == LAYER1)  
	  {
	    if (col1 == col2)  
	      {
		for (row=row1;  row <= row2;  row++)  
		  ROUTING->layer1[row][col1] = netid;
	      }
	    else
	      if (row1 == row2)  
		{
		  for (col=col1;  col <= col2;  col++)  
		    ROUTING->layer1[row1][col] = netid;
		}
	  }
	else
	  if (layer == LAYER2)  
	    {
	      if (col1 == col2)  
		{
		  for (row=row1;  row <= row2;  row++)  
		    ROUTING->layer2[row][col1] = netid;
		}
	      else
		if (row1 == row2)  
		  {
		    for (col=col1;  col <= col2;  col++)  
		      ROUTING->layer2[row1][col] = netid;
		  }
	    }
      }
  }

    for (via=vialist; via != NULL; via=via->next)  {
	 col = via->x;
	 row = via->y;
	 ROUTING->layer1[row][col] = ROUTING->layer2[row][col] = via->netid;
    }
    printf("Complete setmatrix.c\n");
}
